
Ext.define('DSS.component.triggerColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.triggercolumn',
    renderer : function(val, metadata, record, colIdx, store, view) {
        var oRecord = val;
        var sResult = "<table>";
        var f1tip = false;
        var f2tip = false;
        var f3tip = false;
        for ( var iIndex = 0; iIndex < oRecord.length; iIndex++) {
            var oAction = oRecord[iIndex];
            sResult += "<tr>";
            switch (oAction.type) {
                case 'device-sensor': {
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString = 'Verbrauchsmeldung '+ oAction.evt + ' von ' + sString + "</td>";
                    sResult += '<td style="padding-right:5px;" colspan="2"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>' + sString;
                    break;
                }
                case 'zone-scene': { // scene,
                    // group,zone,force
                    var sString = '<td style="padding-right:5px;">'
                            + dss.staticDataModel.getImageForScene(oAction.zone, oAction.group, oAction.scene) + "</td>";

                    sString += "<td>" + dss.staticDataModel.getNameForScene(oAction.zone, oAction.group, oAction.scene);
                    if (oAction.group != 0)
                        sString += " f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += " in " + dss.staticDataModel.getNameForZone(oAction.zone);
                    if (oAction.force)
                        sString += ' !';
                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'device-scene': {
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    switch (oAction.scene) {
                        case 50:
                            sString = 'Lokal aus von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                    + sString + "</td>";
                        break;
                        case 51:
                            sString = 'Lokal ein von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                    + sString + "</td>";
                        break;
                    }
                    sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                    break;
                }
                case 'device-msg': { // value, dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    switch (oAction.msg) {
                        case 7:
                        case 0:
                            if (f1tip == false) {
                                sString = '1x Klick von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                        + sString + "</td>";
                                sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                            }
                            f1tip = true;
                        break;
                        case 8:
                        case 1:
                            if (f2tip == false) {
                                sString = '2x Klick von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                        + sString + "</td>";
                                sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                            }
                            f2tip = true;
                        break;
                        case 9:
                        case 2:
                            if (f3tip == false) {
                                sString = '3x Klick von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                        + sString + "</td>";
                                sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                            }
                            f3tip = true;
                        break;
                        case 3:
                            sString = '4x Klick von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                    + sString + "</td>";
                            sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                        break;
                        case 6:
                            sString = 'Halten von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                    + sString + "</td>";
                            sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                        break;
                        case 10:
                            sString = 'Kurz-Lang-Klick von ' + '<img src="' + dss.staticDataModel.getImageForDevice(oDevice)
                                    + '"></td><td>' + sString + "</td>";
                            sResult += '<td style="padding-right:5px;" colspan="2">' + sString;
                        break;
                    }

                    break;
                }
                case 'custom-event': { // event
                    sResult += '<td colspan="2">Handlung: ' + dss.staticDataModel.getHLENameFromId(oAction.event) + '</td>';
                    break;
                }
            }
            sResult += "</tr>";
        }
        return sResult + "</table>";
    }
});

Ext.define('DSS.component.actionColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.actioncolumn',
    renderer : function(val, metadata, record, colIdx, store, view) {
        var oRecord = val;
        var sResult = "<table>";

        for ( var iIndex = 0; iIndex < oRecord.length; iIndex++) {
            var oAction = oRecord[iIndex];
            sResult += "<tr>";
            switch (oAction.type) {
                case 'zone-value': { // scene, group,zone,force
                    var sString = '<td colspan="2" style="color:#ff0000;">' + Math.round(oAction.value / 2.55) + "%";
                    if (oAction.group != 0)
                        sString += " f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += " in " + dss.staticDataModel.getNameForZone(oAction.zone);
                    else
                        sString += " in allen R&auml;umen";

                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'zone-scene': { // scene, group,zone,force
                    var sError="";
                    if (oAction.zone != 0)
                        if (oAction.scene > 63)
                            sError="color:#ff0000;";
                    if (oAction.group != 0)
                        if (oAction.scene > 63)
                            sError="color:#ff0000;";
                    var sString = '<td style="padding-right:5px;'+sError+'">'
                            + dss.staticDataModel.getImageForScene(oAction.zone, oAction.group, oAction.scene) + "</td>";

                    sString += "<td>";
                    if (oAction.force)
                        sString += 'Alles ';                    
                    sString += dss.staticDataModel.getNameForScene(oAction.zone, oAction.group, oAction.scene);
                    if (oAction.group != 0)
                        sString += " f&uuml;r " + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone != 0)
                        sString += " in " + dss.staticDataModel.getNameForZone(oAction.zone);
                    else 
                        if (oAction.scene < 64)
                            sString += " in allen R&auml;umen";
                    sString += "</td>";
                    sResult += sString;
                    break;
                }
                case 'device-scene': {// scene, dsid,force
                    var sError="";
                    if (oAction.scene > 63)
                        sError="color:#ff0000;";

                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);

                    var sString = oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);

                    if (oAction.scene == 13) {// aus
                        sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                + sString + " ausschalten</td>";
                    } else if (oAction.scene == 14) {// ein
                        sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                + sString + " einschalten</td>";
                    } else if (oAction.scene == 51) { // ein loc
                        sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td><td>'
                                + sString + " einschalten mit Lokalpriorit&auml;t</td>";
                    } else {
                        sString = dss.staticDataModel.getNameForScene(oDevice.ZoneID, oDevice.GroupID, oAction.scene) + " f&uuml;r " + sString+ "</td>";
                        if (oAction.force)
                            sString = 'Alles ' + sString;
                        sString = '<td style="padding-right:5px;'+sError+'">'
                                + dss.staticDataModel.getImageForScene(oDevice.ZoneID, oDevice.GroupID, oAction.scene) + "</td><td>" + sString;
                    }
                    sResult += sString;

                    break;
                }
                case 'device-value': { // value, dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                    var sString = '<td colspan="2" style="color:#ff0000;">' + Math.round(oAction.value / 2.55) + "% f&uuml;r ";
                    sString += oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString += "</td>";
                    sResult += sString;

                    break;
                }
                case 'device-blink': {// dsid
                    var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                    var sString = '<td style="padding-right:5px;"><img src="' + dss.staticDataModel.getImageForDevice(oDevice) + '"></td>';
                    sString += "<td>" + oDevice.name + " in ";
                    sString += dss.staticDataModel.getNameForZone(oDevice.ZoneID);
                    sString += " blinkt</td>";
                    sResult += sString;
                    break;
                }
                case 'zone-blink': {// group,zone
                    var sString = '<td style="padding-right:5px;"><img src="framework/images/sceneIcons/scene_blink.png"></td>';
                    sString += "<td>" + dss.staticDataModel.getNameForGroup(oAction.zone, oAction.group);
                    if (oAction.zone!=0)
                        sString += " in " + dss.staticDataModel.getNameForZone(oAction.zone);
                    else
                        sString += " in allen R&auml;umen";
                    sString += " blinkt</td>";
                    sResult += sString;
                    break;
                }
                case 'custom-event': { // event
                    sResult += '<td colspan="2">Handlung: ' + dss.staticDataModel.getHLENameFromId(oAction.event) + '</td>';
                    break;
                }
                case 'url': { // url
                    sResult += '<td colspan="2">URL: ' + oAction.url + '</td>';
                    break;
                }
            }
            sResult += "</tr>";
        }
        return sResult + "</table>";
    }
});

Ext.define('DSS.component.timespanColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.timespancolumn',
    renderer: function(val) {
        var pad = function(i) { return (i < 10 ? '0'+i : i); };
        var sec = val;
        var min = Math.floor(sec / 60);
        sec -= min * 60;
        var hou = Math.floor(min / 60);
        min -= hou * 60;
        return pad(hou) +':'+ pad(min) +':'+ pad(sec);
    },
});

Ext.define('DSS.component.textColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.textcolumn',
    renderer : function(val) {
        return unescape(val);
    }
});

Ext.define('DSS.component.checkColumn', {
    extend: 'Ext.grid.column.Column',
    alias: 'widget.disabledcolumn',
    
    constructor: function() {
        this.addEvents('checkchange');
        this.callParent(arguments);
    },

    processEvent: function(type, view, cell, recordIndex, cellIndex, e) {
        if (type == 'mousedown') {
            var record = view.panel.store.getAt(recordIndex);
            var dataIndex = this.dataIndex;
            var checked = !record.get(dataIndex);
                
            record.set(dataIndex, checked);
            this.fireEvent('checkchange', this, record, recordIndex, checked);
            return this.callParent(arguments);
        }
    },

    renderer : function(value){
        if (!value) {
            return '<div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif); background-position: 0px -13px;" />';
        } else {
            return '<div style="width:13px;height:13px;background-image:url(' + dss.staticDataModel.baseImagePath + 'dss/checkbox.gif);" />';            
        }
    }
});


Ext.define('DSS.component.timeColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.timecolumn',
    renderer: function(val) {
        var pad = function(i) { return (i < 10 ? '0'+i : i); };
        if (val.timeBase=="daily") {
            var sText=pad(Math.floor(Math.abs(val.offset/3600))) + ":" +
            pad(Math.floor(Math.abs(val.offset/60)%60)) + " Uhr"
            return sText;
        } else {
            
            var sText=pad(Math.floor(Math.abs(val.offset/3600))) + ":" +
            pad(Math.floor(Math.abs(val.offset/60)%60));
            //+ ":" + pad(Math.abs(Math.floor(val.offset%60)));
            switch (val.timeBase)
            {
                case 'sunset':
                    if (val.offset==0)
                        sText = "Bei Sonnenuntergang";
                    else if (val.offset<0)
                        sText += " vor Sonnenuntergang";
                    else
                        sText += " nach Sonnenuntergang";
                break;
                case 'sunrise':
                    if (val.offset==0)
                        sText = "Bei Sonnenaufgang";
                    else if (val.offset<0)
                        sText += " vor Sonnenaufgang";
                    else
                        sText += " nach Sonnenaufgang";
                break;
                case 'dawn':
                    if (val.offset==0)
                        sText = "Bei Morgend&auml;mmerung";
                    else if (val.offset<0)
                        sText += " vor Morgend&auml;mmerung";
                    else
                        sText += " nach Morgend&auml;mmerung";
                break;
                case 'dusk':
                    if (val.offset==0)
                        sText = "Bei Abendd&auml;mmerung";
                    else if (val.offset<0)
                        sText += " vor Abendd&auml;mmerung";
                    else
                        sText += " nach Abendd&auml;mmerung";
                 break;
            }
            if (val.limitBefore!=null)  {
                sText+="<br>aber sp&auml;testens um "+
                    pad(Math.floor(Math.abs(val.limitBefore/3600))) + ":" +
                    pad(Math.floor(Math.abs(val.limitBefore/60)%60)) + " Uhr"
            }
            if (val.limitAfter!=null)  {
                sText+="<br>aber fr&uuml;hestens um "+
                    pad(Math.floor(Math.abs(val.limitAfter/3600))) + ":" +
                    pad(Math.floor(Math.abs(val.limitAfter/60)%60)) + " Uhr"                
            }
            return sText;
        }
    }
});

Ext.define('DSS.component.recurrenceColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.recurrencecolumn',
    renderer: function(val) {
        if (val.recurrenceBase=="weekly") {
            var sString = "<span>";
            
            var fMo = false;
            var fDi = false;
            var fMi = false;
            var fDo = false;
            var fFr = false;
            var fSa = false;
            var fSo = false;
            if (val.timeArray!=null) {
                var recObject = val.timeArray;
                if (recObject.length == 7)
                    return sString + "t&auml;glich</span>";
                for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                    if (recObject[iIndex] == 'MO')
                        fMo = true;
                    if (recObject[iIndex] == 'TU')
                        fDi = true;
                    if (recObject[iIndex] == 'WE')
                        fMi = true;
                    if (recObject[iIndex] == 'TH')
                        fDo = true;
                    if (recObject[iIndex] == 'FR')
                        fFr = true;
                    if (recObject[iIndex] == 'SA')
                        fSa = true;
                    if (recObject[iIndex] == 'SU')
                        fSo = true;
                }
                if (recObject.length == 2)
                    if (fSa)
                        if (fSo)
                            return sString + 'am Wochenende</span>';
        
                if (recObject.length == 5)
                    if (fMo)
                        if (fDi)
                            if (fMi)
                                if (fDo)
                                    if (fFr)
                                        return sString + 'MO-FR</span>';
                if (recObject.length == 1) {
                    if (fMo)
                        return sString + "Montags</span>";
                    if (fDi)
                        return sString + "Dienstags</span>";
                    if (fMi)
                        return sString + "Mittwochs</span>";
                    if (fDo)
                        return sString + "Donnerstags</span>";
                    if (fFr)
                        return sString + "Freitags</span>";
                    if (fSa)
                        return sString + "Samstags</span>";
                    if (fSo)
                        return sString + "Sonntags</span>";
                }
                if (recObject.length == 0) {
                    return sString + "keine Zeiten</span>";                
                }
            } else 
                return sString + "keine Zeiten</span>";
            
            if (fMo)
                sString += '<b>MO</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">MO</span> ,';
            if (fDi)
                sString += '<b>DI</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">DI</span> ,';
            if (fMi)
                sString += '<b>MI</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">MI</span> ,';
            if (fDo)
                sString += '<b>DO</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">DO</span> ,';
            if (fFr)
                sString += '<b>FR</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">FR</span> ,';
            if (fSa)
                sString += '<b>SA</b> ,';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">SA</span> ,';
            if (fSo)
                sString += '<b>SO</b>';
            else
                sString += '<span style="color:#aaaaaa;text-decoration:line-through;">SO</span>';
            return sString + "</span>";
        } else {
            var sText="<table>";
            if (val.timeArray!=null) {
                for (var iIndex=0;iIndex<val.timeArray.length;iIndex++) {
                    var oDate=new Date(val.timeArray[iIndex]);
                    
                    sText+="<tr><td>" + Ext.Date.format(oDate, "l, d.m.Y") + "</td></tr>";
                }
            }
            return sText+"</table>";
        }
    },
});

Ext.define('DSS.component.timeStampColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.timestampcolumn',
    renderer: function(val) {
        
        var pad = function(i) { return (i < 10 ? '0'+i : i); };
        
        if (val == null) {
            return _('-');
        } else if (val == "") {
            return _('-');
        } else {
            var oRecord = val;
            var oDate = new Date();
            oDate.setTime(parseInt(oRecord,10));
            return pad(oDate.getDate()) + "." + pad(oDate.getMonth() + 1) + "." + oDate.getFullYear() + " - " + pad(oDate.getHours())
                    + ":" + pad(oDate.getMinutes()) + ":" + pad(oDate.getSeconds());
        }
    }
});

Ext.define('DSS.component.EmailColumn', {
    extend : 'Ext.grid.column.Column',
    alias : 'widget.emailcolumn',
    renderer: function(val) {
        var triggerObject = val;
        if (triggerObject.messageType == 'email')
            return '<table><tr><td rowspan="3"><image src="images/dss/email.png"></td>'
                    + '<td rowspan="3" style="width:5px;"><image src="framework/images/t.gif"></td>' + '<td>Empf&auml;nger:</td><td>'
                    + triggerObject.receiver + '</td></tr>' + '<tr><td>Betreff:</td><td>' + unescape(triggerObject.subject) + '</td></tr>'
                    + '<tr><td>Nachricht:</td><td>' + unescape(triggerObject.message) + '</td></tr></table>';
        else
            return "eine Nachricht";
    }
});


Ext.apply(Ext.data.SortTypes, {
    asTimestamp: function(oValue) {
        if (oValue == null) {
            return 0;
        } else if (oValue == "") {
            return 0;
        } else {
            return parseInt(oValue,10);
        }        
    },
    asTimespan: function(oValue) {
        return oValue;
    },
    asTrigger: function(oValue) {
        var pad10 = function(i) { 
            var sString=""+i
            while (sString.length<10)
                sString="0"+sString;
            return sString;
        };
        var sRetVal="";;
        var oAction = oValue[0];
        switch (oAction.type) {
            case 'zone-scene': { // scene,
                sRetVal="0";
                sRetVal += pad10(oAction.group);
                sRetVal += pad10(oAction.scene);
                sRetVal += pad10(oAction.zone);
                break;                
            }
            case 'device-scene': {
                sRetVal="1";
                var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                sRetVal += pad10(oDevice.ZoneID);
                sRetVal += oAction.dsid;
                sRetVal += pad10(oAction.scene);
                break;
            }
            case 'device-msg': {
                sRetVal="2";
                var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                sRetVal += pad10(oDevice.ZoneID);
                sRetVal += oAction.dsid;
                sRetVal += pad10(oAction.msg);
                break;
            }
            case 'custom-event': {
                sRetVal="3";
                sRetVal+=dss.staticDataModel.getHLENameFromId(oAction.event);
                break;
            }
            case 'device-sensor': {
                sRetVal="4";
                var oDevice = dss.staticDataModel.getDevice(oAction.dsid);
                sRetVal += pad10(oDevice.ZoneID);
                sRetVal += oAction.dsid;
                sRetVal += pad10(oAction.evt);
                break;
            }
        }
        return sRetVal;
    },
    asBoolean: function(oValue) {
        return (oValue==true)?1:0;
    }, 
    asEmail: function(oValue) {
        return oValue.receiver+'_' + oValue.subject;
    },
    asAction: function(oValue) {
        var pad10 = function(i) { 
            var sString=""+i
            while (sString.length<10)
                sString="0"+sString;
            return sString;
        };
        var oSelectValue=oValue[0];
        var sRet="";
        switch (oSelectValue.type){
            case 'zone-scene': {
                sRet="0";
                sRet += pad10(oSelectValue.group);
                sRet += pad10(oSelectValue.scene);
                sRet += pad10(oSelectValue.zone);
                break;
            }
            case 'zone-blink': {
                sRet="1";
                sRet += pad10(oSelectValue.group);
                sRet += pad10(oSelectValue.zone);
                break;
            }
            case 'device-scene': {
                sRet="2";
                var oDevice = dss.staticDataModel.getDevice(oSelectValue.dsid);
                sRet += pad10(oDevice.ZoneID);
                sRet += oSelectValue.dsid;
                sRet += pad10(oSelectValue.scene);
                break;
            }
            case 'device-blink': {
                sRet="3";
                var oDevice = dss.staticDataModel.getDevice(oSelectValue.dsid);
                sRet += pad10(oDevice.ZoneID);
                sRet += oSelectValue.dsid;
                break;
            }
            case 'device-value': {
                sRet="4";
                var oDevice = dss.staticDataModel.getDevice(oSelectValue.dsid);
                sRet += pad10(oDevice.ZoneID);
                sRet += oSelectValue.dsid;
                sRet += oSelectValue.value;
                break;
            }
            case 'custom-event': {
                sRet="5";
                sRet+=dss.staticDataModel.getHLENameFromId(oSelectValue.event);
                break;
            }
            case 'url': {
                sRet="6";          
                sRet+=oSelectValue.url;
                break;
            }
        }
        return sRet;
    },    
    asTime: function(oValue){
        var retValue=0;
        switch (oValue.timeBase)
        {
            case 'sunset':
                retValue=350000;
            break;
            case 'sunrise':
                retValue=250000;
            break;
            case 'dawn':
                retValue=150000;
            break;
                retValue=450000;
             break;
        }
        retValue+=oValue.offset;
        return retValue;
    },    
    asRecurrence: function(oValue){
        if (oValue.timeArray!=null) {
            var recObject = oValue.timeArray;
            var fMo = false;
            var fDi = false;
            var fMi = false;
            var fDo = false;
            var fFr = false;
            var fSa = false;
            var fSo = false;
            if (recObject.length == 7)
                return 0;
            for ( var iIndex = 0; iIndex < recObject.length; iIndex++) {
                if (recObject[iIndex] == 'MO')
                    fMo = true;
                if (recObject[iIndex] == 'TU')
                    fDi = true;
                if (recObject[iIndex] == 'WE')
                    fMi = true;
                if (recObject[iIndex] == 'TH')
                    fDo = true;
                if (recObject[iIndex] == 'FR')
                    fFr = true;
                if (recObject[iIndex] == 'SA')
                    fSa = true;
                if (recObject[iIndex] == 'SU')
                    fSo = true;
            }
            if (fSa)
                if (fSo)
                    if (!fMo)
                        if (!fDi)
                            if (!fMi)
                                if (!fDo)
                                    if (!fFr)
                                        return 20;
            if (!fSa)
                if (!fSo)
                    if (fMo)
                        if (fDi)
                            if (fMi)
                                if (fDo)
                                    if (fFr)
                                        return 10;
            if (recObject.length!=1) {
                var iReturnValue=100;
                if (fMo)
                    iReturnValue+=1;
                if (fDi)
                    iReturnValue+=2;
                if (fMi)
                    iReturnValue+=4;
                if (fDo)
                    iReturnValue+=8;
                if (fFr)
                    iReturnValue+=16;
                if (fSa)
                    iReturnValue+=32;
                if (fSa)
                    iReturnValue+=64;
                return iReturnValue;
            } else {
                if (fMo)
                    return 201;
                if (fDi)
                    return 202;
                if (fMi)
                    return 203;
                if (fDo)
                    return 204;
                if (fFr)
                    return 205;
                if (fSa)
                    return 206;
                if (fSo)
                    return 207;
            }
        }
        return 1000;
    }
});